v 10.6.7
  - Commit.find returns nil and no longer throws an error on an empty repository

v 10.6.6
  - The Git attributes parser can now parse file paths without any attributes

v 10.6.5
  - Retain file mode whenever file is renamed

v 10.6.4
  - Diff sizes are now checked before loading any extra data into memory

v 10.6.3
  - When parsing Git attributes "diff" is now set to false whenever "binary" is set to true

v 10.6.2
  - Fix parsing Git attributes defined using an absolute path

v 10.6.1
  - Fix parsing Git attributes when $GIT_DIR/info/attributes doesn't exist

v 10.6.0
  - Use a pure Ruby Git attributes file parser to drastically reduce time spent in parsing Git attributes

v 10.5.0
  - Add Repository#find_branch to speed up branch lookups
  - Add Repository#reload_rugged to force a refresh of the Rugged repository

v 10.4.7
  - Remove unneeded call to Repository#root_ref

v 10.4.6
  - Optimize fetch of the author and committer of a Rugged commit

v 10.4.5
  - Write .gitattributes in binary mode to prevent Rails from converting ASCII-8BIT to UTF-8
  - Compare returns an empty collection of commits on nil refs

v 10.4.4
  - Lazy load compare commits

v 10.4.3
  - Cleanup local branches after creation to make rspec pass
  - rubocop-rspec version compatible with ruby 2.1
  - Add deltas_only option for  DiffCollection

v 10.4.2
  - Improve performance of a decorated DiffCollection instance

v 10.4.1
  - Expose tags git object sha (if it's an annotated tag)

v 10.4.0
  - Move implementation of `local_branches` to `Gitlab::Git::Repository` from gitlab-ce
  - Refactor Refs to preserve their target objects instead of just a string representation

v 10.3.2
  - Handle collapsable DiffCollection

v 10.3.1
  - Optional ref update on commit create

v 10.3.0
  - Remove Repository#format_patch
  - Remove Repository#add_tag
  - Rename a repository file

v 10.2.3
  - Handle nil blob data

v 10.2.2
  - Revert Repository#format_patch removal

v 10.2.1
  - Fix bug where truncated? would always be true for ISO-8859 files

v 10.2.0
  - Add Repository#branch_exists? to check if a branch exists
  - Fix bug where truncated? would erroneously change after the first iteration

v 10.1.4
  - Fix truncated? for Unicode-encoded blobs

v 10.1.3
  - Increase the max amount of blob data to load from 1K to 10 MB

v 10.1.2
  - DiffCollections now enforce a total byte limit of 5 KB * max_files

v 10.1.1
  - load_all_data! only does one lookup per blob

v 10.1.0
  - Added Repository#tag_exists?

v 10.0.2
  - Allow get commits before or after a specific date

v 10.0.1
  - Only force_encode strings to detected encoding if confidence is above threshold.

v 9.0.3
  - Add a method to copy the .gitattributes into the bare repository

v 9.0.2
  - Exclude merge commits in format_patch method (Stan Hu)

v 9.0.1
  - Speed up `git log`

v 9.0.0
  - BREAKING: return DiffCollections from #diffs methods

v 8.2.0
  - Upgrade Rugged to 0.24.0b13

v 8.1.0
  - Added Gitlab::Git::Repository#count_commits_between

v 8.0.0
  - Fix repository size calculation
  - BREAKING: Only load blob data on demand (no longer eagerly)

v 7.2.24
  - Improve performance of discover_default_branch
  - Added Repository#branch_count
  - Lazy-load Repository#root_ref

v 7.2.23
  - Allow Commit.between to take branch names as well as shas.

v 7.2.22
  - Add Repository#ls_files method

v 7.2.21
  - Add checks if blob is a lfs pointer, values for size and oid.

v 7.2.20
  - Switch back to GitHub Linguist and bump rugged and other gem versions
  - Add method on repository to create branch
  - Allow annotated tags to be created

v 7.2.19
  - Return archive metadata, do not create archives

v 7.2.18
  - Support capability to reject updating of existing files (Stan Hu)
  - Preserve file mode when updating existing file (Stan Hu)
  - Add mkdir support with an empty .gitkeep file (Stan Hu)

v 7.2.17
  - Ensure empty commits are returned by Commit.where (Rémy Coutable)

v 7.2.16
  - Strip leading slashes in blob path to resolve filenames properly (Stan Hu)
  - Also nice+ionice 'git archive' itself

v 7.2.15
  - Handle `git blame` for files encoded in different formats (e.g. ISO-8859) (Stan Hu)

v 7.2.14
  - Ignore CRLFs in .gitmodules (Stan Hu)

v 7.2.13
  - Fix Blob#commit when pass full ref like refs/head/master

v 7.2.12
  - Improved performance of git blame

v 7.2.11
  - Fix regression in 7.2.9 causing log method to throw an exception given an unknown ref (Stan Hu)

v 7.2.10
  - Disable auto-CRLF correction for binary files (Stan Hu)

v 7.2.9
  - Optimization of file history method

v 7.2.8
  - Ignore symbolic refs that point to deleted branches (Stan Hu)

v 7.2.7
  - Order result of `Repository#commits_between` by date.
  - Include branch/tag name in archive file and dirname

v 7.2.6
  - Ignore remote/symbolic refs when creating repository's refs_hash (Stan Hu)

v 7.2.5
  - Take value of autocrlf into account when committing blobs.

v 7.2.4
  - Add Repository#enable_autocrlf method.

v 7.2.3
  - Fix Blob.commit and Blob.remove for non-master branches

v 7.2.2
  - Added Blob.remove feature

v 7.2.1
  - Fix committing blog to empty repository

v 7.2.0
  - Added Blob.commit feature

v 7.1.13
  - Update rugged to 0.22.2 to fix segfault.

v 7.1.12
  - Fix broken view when viewing history of a file that includes a path that used to be another file. (Stan Hu)

v 7.1.11
  - Fix broken view when using a tag to display a tree that contains git submodules. (Stan Hu)

v 7.1.10
  - Ignore submodules that are defined in .gitmodules but are checked in as directories. (Stan Hu)

v 7.1.9
  - Ignore invalid lines in .gitmodules. (Stan Hu)

v 7.1.8
  - Don't use git clone/fetch quiet flag since it's too new.

v 7.1.7
  - Add Repository#bare? method

v 7.1.6
  - Fix blob mode to return string rather than int.

v 7.1.5
  - Don't strip final newline of diff.

v 7.1.4
  - Fix nil blob mode (Sullivan Sénéchal)

v 7.1.3
  - Improve the to_patch and to_diff methods for merge commits
  - Prevent parallel archiving of same repo/ref/format.

v 7.1.2
  - Finding commit by invalid rev returns nil instead of error.

v 7.1.1
  - Verify found object is actually a commit in Commit.find

v 7.1.0
  - Convert encoding of all freeform text to UTF-8.

v 7.0.0
  - Move everything to rugged. Drop gitlab-grit dependency
  - Removed GitLab-only specific classes: GitStats, Stats, LogParser

v 6.3.0
  - Get messages for annotated tags (Sean Edge)
  - Blame using rugged (Evgeniy Sokovikov)

v 6.2.1
  - Fix Branch.new method for branch "origin/HEAD" because it points on ref instead of commit.

v 6.2.0
  - When archive repository - use storage path for temp files too
  - Updated rugged to 0.21

v 6.1.0
  - Remove limit parameter from Compare.new method
  - Prevent 'undefined method' exception when pass wrong ref to Compare

v 6.0.1
  - Use tmp file for archive repository unless file is ready

v 6.0.0
  - Add Repository#commit_count method

v 5.9.0
  - Performance improvements for Commit#find method

v 5.8.0
  - Less strict dependency rules
  - Updated gems
  - Use the new shell command style

v 5.7.1
  - Fixed branch discover if master does not exist

v 5.7.0
  - Fixed issue with bz2 archive not being created (Jason Hollingsworth)
  - Fixed branch discover if HEAD has not been updated to one of the existing branches (Jason Hollingsworth)

v 5.6.0
  - Rename Tree#contribution? to Tree#contributing?
  - Use new light seed repo

v 5.5.0
  - Add Tree#contribution? method

v 5.4.0
  - Get rid of BROKEN_DIFF constant
  - Diff.between raises exception in case of timeout now
  - Add tests to Compare
  - Cache diff result for Compare

v 5.3.0
  - Add Repository#submodules method

v 5.2.0
  - Add EncodingHelper. Encode blob data to utf8

v 5.1.0
  - Added rugged dependency
  - Git::Tag and Git::Branch objects
  - Branch, Tag, Tree uses rugged
  - Blob use rugged

v 5.0.0
  - Use new version of linguist

v 4.1.0
  - Allow to specify diff paths
  - Remove pygments dependency

v 4.0.0
  - use activesupport v4
  - Add support for raw blob search
  - Add support for zip archives

v 3.1.0
  - use gitlab dependencies (linguist, pygments)

v 3.0.0
  - Refactor Git::Tree
  - Refactor Git::Blob
  - Refactored Git::Repository

v 2.3.0
  - Better ref detection
  - Fixed empty repo bug

v 2.2.0
 - Fixed Compare showing wrong diff

v 1.4.0
  - Update gitlab_grit dependency to 2.6.0

v 1.3.0
  - Added GitStats and LogParser classes

v 1.2.1
  - fixed commit stats

v 1.2.0
  - Use gitlab-grit instead of grit
  - removed grit_ext dependency also

v 1.1.0
  - new method Repository#search_files added
  - new class BlobSnippet added (for search results)

v 1.0.6
  - new method Tree#submodules added
